/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    December 9th, 2005
 Update:  December 9th, 2005
 Program: This is software for the EMGNJ method with Asger Hobolth.

********************************************************************/

#ifndef FELSENSTEIN__H
#define FELSENSTEIN__H

#include <lapack++.h>
#include <lapack.h>
#include <lafnames.h>
#include <iostream>

LaGenMatDouble Transposition(LaGenMatDouble A, int N);

void getEmpFreq(double **FreqVec, int **SeqMat, int seqLn, int n,
		int numSt);

void getEmpFreq(double **FreqVec, int **SeqMat, int seqLn, int n,
		int numSt);

void computeEvalEvec(LaSymmMatDouble RateMat, LaGenMatDouble& InvFEgnVc,
		     LaGenMatDouble& TspFEgnVc, LaVectorDouble& EVal,
		     LaGenMatDouble& EigenRate,
		     LaVectorDouble FreqVec, int StateNum);

void computeEvalEvec2(LaGenMatDouble RateMat, LaGenMatDouble& InvFEgnVc,
		     LaGenMatDouble& TspFEgnVc, LaVectorDouble& EVal,
		     LaGenMatDouble& EigenRate,
		     LaVectorDouble FreqVec, int StateNum);

void FstFlsnFct(int** TreeMatrix, LaVectorDouble EgnVl, 
		LaGenMatDouble InvFEgnVc, 
		LaGenMatDouble TspFEgnVc, LaVectorDouble BranchLength, 
		LaVectorDouble Frq, int* Obs, int numSt, int numLvs, 
		int numNds, LaGenMatDouble & CndProbMat, long double & logL);

void FlsnFct(int** TreeMatrix, LaSymmMatDouble RateMat, LaVectorDouble Frq, 
	     LaVectorDouble BranchLength, int* Obs, int numSt, int numLvs, 
	     int numNds, LaGenMatDouble & CndProbMat, long double & logL);

LaGenMatDouble CndStatFct(LaVectorDouble Frq, LaSymmMatDouble Q, 
			  int numSt);

LaSymmMatDouble GTRRateMFct(LaVectorDouble Frq, LaVectorDouble Tht,
			    int numOfSts);

void getEmpFreq(LaVectorDouble &FreqVec, int **SeqMat, int seqLn, int n,
		int numSt);

LaGenMatDouble RateToProbFun(LaSymmMatDouble RateMat, 
			     double Tau, LaVectorDouble FreqVec, int StateNum);


LaGenMatDouble GTRRateMFct2(LaVectorDouble Frq, LaVectorDouble Tht,
			   int numOfSts);

LaGenMatDouble RateToProbFun2(LaGenMatDouble RateMat, 
			     double Tau, LaVectorDouble FreqVec, int StateNum);

void FlsnFct2(int** TreeMatrix, LaGenMatDouble RateMat, LaVectorDouble Frq, 
	     LaVectorDouble BranchLength, int* Obs, int numSt, int numLvs, 
	     int numNds, LaGenMatDouble & CndProbMat, long double & logL);

LaGenMatDouble CndStatFct2(LaVectorDouble Frq, LaGenMatDouble Q, 
			   int numSt);
#endif
