/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    June 6th, 2004
 Update:  February 24th, 2005
  
 Comments: Get index from the table.
 
***********************************************************************/
#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>

#include "Taxa.h"
 
void Subsets2(int N, int M, int I, int K, int *array, ofstream & out)
{
    //If we have already excluded too many items, then return
  
    if((M-K) == (N-I+1))
         return;
 
 
    //if we have finished comuting a subset, then print it out
     
    if((M-K) == 0)
    {
        for(int i = 0; i < N; i++)
             if(array[i] == 1)
                 out << i << "  ";
 
         out << endl;
         return;
     }
 
 
        
    int newArray[N];
    for(int i = 0; i < N; i++) newArray[i] = 0;
 
    //copy the K precomputed values from array[]
 
    for(int i = 0; i < I; i++)
        newArray[i] = array[i];
 
 
     //compute all subsets where we choose element I
     newArray[I] = 1;
     Subsets2(N, M, I+1, K+1, newArray, out);
 
     //compute all subsets where we DON'T choose element I
     newArray[I] = 0;
     Subsets2(N, M, I+1, K, newArray, out);
 
    return;
    
 
}
 
 
int getList2(int N, int M){

  int array[N];

  for(int i = 0; i < N; i++) array[i] = 0;
  //Print out all subsets of size M
 
  ofstream out;
  out.open("ListOfSubsets");

  Subsets2(N, M, 0, 0, array, out);

  return 0;
}
 
using namespace std;


long long int Choose(int n, int m){
  long long int f = 1, i;
  long long int numOfWts = 0;
  if(n == 0) return 0;
  else{
    if(m <= n/2){
      for(i = 0; i < m; i++)  f *= (n - i);
      for(i = 1; i <= m; i++) f /= i;
    }
    else{
      int mm = n - m;
      for(i = 0; i < mm; i++)  f *= (n - i);
      for(i = 1; i <= mm; i++) f /= i;
    }
    numOfWts = f;
    
    return numOfWts;
  }
}

int IndexNumber(int n, int m, int * array){
  int f = 1, j = 0;
  array[0] = 0;
  for(j = 1; j < m; j++){
//     for(i = 1; i < (array[j] - array[j - 1]); i++){
//       //cout << (n - array[j - 1] - 1) - (i - 1) << " " << m - j<< endl;
//       f += Choose(n - array[j - 1] - i, m - j); 
//     } 
    f += (Choose((n - array[j - 1]), m - j + 1) - Choose((n - array[j] + 1), m - j + 1)); //cout << f << endl;
  }

  f += (array[m] - array[m - 1] - 1);

  return f;
}

int getIndexNumber(int n, int m, int * array){
  int i = 0, newArray[m + 1];
  newArray[0] = 0;
  for(i = 0; i < m; i++) newArray[i + 1] = array[i];
  return IndexNumber(n, m, newArray);
}

double Sum1(int n, int m, int i, Taxa * data){

  double sum = 0;
  int numOfrows = Choose(n - 1, m - 1), j = 0, k = 0, tmp[m];
  int index[numOfrows][m];
  
  getList2(n - 1, m - 1);
  
  ifstream in;
  in.open("ListOfSubsets");
  sum = 0;
  for(j = 0; j < numOfrows; j++){
    for(k = 0; k < (m - 1); k++){
      tmp[k] = 0;
      in >> tmp[k];
      tmp[k]++;
      if(tmp[k] == i)
	{index[j][k] = n; tmp[k] = n;}
      else index[j][k] = tmp[k];
      //  tmp = 0;
    }    
    
    index[j][m - 1] = i;
    tmp[m - 1] = i;
    bubblesort(m, index[j]);
    bubblesort(m, tmp);
    //if(data[getIndexNumber(n, m, index[j]) - 1].wt != 0)
      sum += data[getIndexNumber(n, m, index[j]) - 1].wt;

    //cout << sum << " ";
    //    for(int s = 0; s < m; s++) cout << data[getIndexNumber(n, m, index[j]) - 1].array[s] << " ";
    //cout << ": " << endl;
    //cout << data[getIndexNumber(n, m, index[j]) - 1].wt << endl;

    for(int s = 0; s < m; s++) 
      if(data[getIndexNumber(n, m, index[j]) - 1].array[s] != tmp[s])
    {for(int ss = 0; ss < m; ss++) cerr << tmp[ss] << " "; cerr<<endl; 
    for(int ss = 0; ss < m; ss++)  cerr<< data[getIndexNumber(n, m, index[j]) - 1].array[ss] << " "; cerr << tmp[s] << endl; exit(1);
    }

  } 
  system("rm ListOfSubsets");
  return sum;
  
}

double Sum2(int n, int m, int i, int J, Taxa * data){
  
  double sum = 0;
  int numOfrows = Choose(n - 2, m - 2), j = 0, k = 0, tmp[m];
  int index[numOfrows][m];
  if(i == J) {
    cerr << "Error on Sum2." << endl;
    exit(0);
  }

  getList2(n - 2, m - 2);
  
  ifstream in;
  in.open("ListOfSubsets");
  
  for(j = 0; j < numOfrows; j++){
    for(k = 0; k < (m - 2); k++){
      tmp[k] = 0;
      in >> tmp[k];
      tmp[k]++;
      if((J != (n - 1)) && (i != n)){
	if(tmp[k] == i)
	  index[j][k] = n - 1;
	else if(tmp[k] == J) index[j][k] = n;
	else index[j][k] = tmp[k];
      }
      else{
	if(tmp[k] == i)
	  index[j][k] = n;
	else if(tmp[k] == J) index[j][k] = n - 1;
	else index[j][k] = tmp[k];
      }
    }    
    
    index[j][m - 2] = i;
    index[j][m - 1] = J;
    bubblesort(m, index[j]);
    //if(data[getIndexNumber(n, m, index[j]) - 1].wt != 0)
      sum += data[getIndexNumber(n, m, index[j]) - 1].wt;

//     cout << sum << " ";
//     for(int s = 0; s < m; s++) cout << data[getIndexNumber(n, m, index[j]) - 1].array[s] << " ";
//     cout << ": " << endl;
//     cout << data[getIndexNumber(n, m, index[j]) - 1].wt << endl;

    for(int s = 0; s < m; s++) 
      if(data[getIndexNumber(n, m, index[j]) - 1].array[s] != index[j][s])
	{ cerr << i << " " << J << endl;
	  for(int ss = 0; ss < m; ss++) cerr << index[j][ss] << " "; cerr<<endl; 
	  for(int ss = 0; ss < m; ss++)  cerr<< data[getIndexNumber(n, m, index[j]) - 1].array[ss] << " "; cerr << endl;
	for(int ss = 0; ss < m; ss++) cerr << tmp[ss] << " "; cerr<<endl; exit(0);
	}
   
  }
  
  system("rm ListOfSubsets");
  
  return sum;
  
}

/************* Only for the original NJ method *****************************/

double Sum1_Original(int n, int i, Taxa * data){

  double sum = 0;
  int numOfrows = n - 1, j = 0;
  int index[numOfrows][2];
  
  sum = 0;
  for(j = 0; j < numOfrows; j++){
    if(i == (j + 1))
      index[j][0] = n;
    else index[j][0] = j + 1;
      index[j][1] = i;
      bubblesort(2, index[j]);
      
      sum += data[getIndexNumber(n, 2, index[j]) - 1].wt;
        
  } 

  return sum;
  
}

double Sum2_Original(int n, int i, int j, Taxa * data){

  int index[2];
  index[0] = i; index[1] = j;

  bubblesort(2, index);

  return data[getIndexNumber(n, 2, index) - 1].wt;
  
}


/***************************** Test *****************************/

void newPreSum1(int N, int M, int I, int K, int *array, double & sum, Taxa * data, int ii)
{
  int n = N + 1, m = M + 1;  
  int index[M + 1], counter = 0;
  
  //If we have already excluded too many items, then return
  
  if((M-K) == (N-I+1))
    return;
  
  
  //if we have finished comuting a subset, then print it out
  
  if((M-K) == 0)
    {
      for(int i = 0; i < N; i++)
	if(array[i] == 1)
	  {  //cout << i << "  ";
	  index[counter] = i + 1; 
	  if(index[counter] == ii)
	    index[counter] = n;
	  counter++;
	  }

      index[m - 1] = ii;
      bubblesort(m, index);

      sum += data[getIndexNumber(n, m, index) - 1].wt;
      
//       for(int k = 0; k <= M; k++) cout << index[k] << " ";
//       cout << endl; 

      //cout << endl;
      return;
     }
 
 
        
    int newArray[N];
    for(int i = 0; i < N; i++) newArray[i] = 0;
 
    //copy the K precomputed values from array[]
 
    for(int i = 0; i < I; i++)
        newArray[i] = array[i];
 
 
     //compute all subsets where we choose element I
     newArray[I] = 1;
     newPreSum1(N, M, I+1, K+1, newArray, sum, data, ii);
 
     //compute all subsets where we DON'T choose element I
     newArray[I] = 0;
     newPreSum1(N, M, I+1, K, newArray, sum, data, ii);
 
    return;
    
}
 
 
double newSum1(int N, int M, int i, Taxa * data){

  int array[N - 1];
  double sum = 0;

  for(int j = 0; j < (N - 1); j++) array[j] = 0;
  //Print out all subsets of size M
 
  newPreSum1(N - 1, M - 1, 0, 0, array, sum, data, i);
 
  return sum;
}
 
void newPreSum2(int N, int M, int I, int K, int *array, double & sum, Taxa * data, int ii, int J)
{
  int n = N + 2, m = M + 2;  
  int index[m], k = 0, tmp[m];
  
  //If we have already excluded too many items, then return
  
  if((M-K) == (N-I+1))
    return;
  
  
  //if we have finished comuting a subset, then print it out
  
  if((M-K) == 0)
    {
      for(int i = 0; i < N; i++)
	if(array[i] == 1)
	  {  // cout << i << "  ";
	    tmp[k] = i + 1;

	    if((J != (n - 1)) && (ii != n)){
	      if(tmp[k] == ii)
		index[k] = n - 1;
	      else if(tmp[k] == J) index[k] = n;
	      else index[k] = tmp[k];
	    }
	    else{
	      if(tmp[k] == ii)
		index[k] = n;
	      else if(tmp[k] == J) index[k] = n - 1;
	      else index[k] = tmp[k];
	    }
	    k++;
	  }
    
      index[m - 2] = ii;
      index[m - 1] = J;
      bubblesort(m, index);
      //if(data[getIndexNumber(n, m, index[j]) - 1].wt != 0)
//       for(k = 0; k < m; k++) cout << index[k] << " ";
//       cout << endl;
      sum += data[getIndexNumber(n, m, index) - 1].wt;
   
      return;
     }
 
 
        
    int newArray[N];
    for(int i = 0; i < N; i++) newArray[i] = 0;
 
    //copy the K precomputed values from array[]
 
    for(int i = 0; i < I; i++)
        newArray[i] = array[i];
 
 
     //compute all subsets where we choose element I
     newArray[I] = 1;
     newPreSum2(N, M, I+1, K+1, newArray, sum, data, ii, J);
 
     //compute all subsets where we DON'T choose element I
     newArray[I] = 0;
     newPreSum2(N, M, I+1, K, newArray, sum, data, ii, J);
 
    return;
    
}
 
 
double newSum2(int N, int M, int i, int j, Taxa * data){

  int array[N - 2];
  double sum = 0;

  for(int k = 0; k < (N - 2); k++) array[k] = 0;
  //Print out all subsets of size M
 
  newPreSum2(N - 2, M - 2, 0, 0, array, sum, data, i, j);
 
  return sum;
}
 
