/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    June 6th, 2004
 Update:  July 24th, 2005
  
Comments: Get index from the table.
 
***********************************************************************/
#ifndef INDEX__H
#define INDEX__H

#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>

#include "Taxa.h"
 
using namespace std;

class Matrix1{
 public:
  int length;
  double * table;
  Matrix1(int n){
    length = n;
    table = new double[length];
    for(int i = 0; i < length; i++)
      table[i] = 0;
  }
  Matrix1(){
    ;
  }
  void Assign(int n){
    length = n;
    table = new double[length];
    for(int i = 0; i < length; i++)
      table[i] = 0;
  }
};

class Matrix{
 public:
  int length;
  Matrix1 * table;
  Matrix(int n){
    length = n;
    table = new Matrix1[length];
    for(int i = 0; i < n; i++){
      table[i].Assign(n);
    }
  }
};

long long int Choose(int n, int m);

int IndexNumber(int n, int m, int * array);

int getIndexNumber(int n, int m, int * array);

double Sum1(int n, int m, int i, Taxa * data);

double Sum2(int n, int m, int i, int J, Taxa * data);

double Sum1_Original(int n, int i, Taxa * data);

double Sum2_Original(int n, int i, int j, Taxa * data);

double newSum1(int N, int M, int i, Taxa * data);

double newSum2(int n, int m, int i, int J, Taxa * data);

#endif

