
/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    June 21st, 2004
 Update:  July 10th, 2004
  
***********************************************************************/
#ifndef NJTREE__H
#define NJTREE__H

#include <iostream.h>
#include <fstream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>

#include "TreeNode.h"
#include "Cherry.h"

using namespace std;

class PhylTree{
 public:
  TreeNode * root;
  PhylTree(){root = NULL;}
  PhylTree(TreeNode * node){
    root = node;
  }

  void printTree(TreeNode* node, int number){
    if(node != 0){
      //      node -> printNode();
      printTree(node -> right, number + 7);
      for(int i = 0; i < number; i++) cout << " ";
      node -> printNode();
      printTree(node -> left, number + 7);
    }
  }
  void DFS(TreeNode* node){
    if(node != 0){
      if(node -> wt != -10000){
	if(node -> name == -1)
	  {
	    cout << "(";
	    DFS(node -> left);
	    cout << ",";
	    DFS(node -> right);
	    cout << ")";
	    cout << ":";
	    cout << node -> wt;
	  }      
	else {
	  cout << node -> RealName;
	  cout << ":";
	  cout << node -> wt;
	}
      }
      else {
	    DFS(node -> left);
	    DFS(node -> right);
      }
    }
  }

  void printTree(){
    cout << endl << "(";
    DFS(root);
    cout << ")" << endl << endl;
  } 
};

void deleteTree(TreeNode* tree);
void assignNum(TreeNode* node);
void computingEdgeWts(TreeNode *tree,int n,int mm,double* leafWts);
void adjustLeafEdgeWts(TreeNode* tree, double* leafWts);

void CreateTreeMatric(Taxa * Data, int n, int m, Taxa * S);
void testNJ(int n, Taxa * S, char** names);
void CreateTree(Taxa * Data, int n, int m, int numOfWeights, char** names);
void CreateTree2(Taxa * Data, int n, int m, int M, int numOfWeights, char** names);
void CreateTree2_Table(Table Data, int n, int m, int mm, int numOfWeights, char** names);
void CreateTree3_Table(Table Data, int n, int m, int mm, int numOfWeights, char** names, char* filename);
TreeNode* CreateTree(Table Data, int n, int m, int mm, int numOfWeights, char** names);

#endif
