/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    December 9th, 2005
 Update:  July 12th, 2006
 Program: This is software for the EMGNJ method with Asger Hobolth.

********************************************************************/

#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>
#include <list.h>

#include <lapack++.h>
#include <lapack.h>
#include <lafnames.h>

#include "TreeNode.h"
#include "Mjoin.h"
#include "NJTree.h"
#include "Seq.h"

using namespace std;

void getListOfNames(char** listOfNames, TreeNode * tree){
  if(tree != NULL){
    if(tree -> name != -1){
      listOfNames[tree -> num - 1] = new char[strlen(tree -> RealName) + 1];
    strcpy(listOfNames[tree -> num - 1], tree -> RealName);
    }
    getListOfNames(listOfNames, tree -> left);
    getListOfNames(listOfNames, tree -> right);
  }
}

void readNewick(ifstream & in, TreeNode * node, int & num, int & n){
  char tmp, *holding, *holding2;
  holding = new char[200];
  holding2 = new char[200];
  int counter = 0;
  if(!in.eof()){
    in >> tmp;
    if(tmp != ';'){
      if(tmp == '('){
	
	TreeNode * left = new TreeNode;
	TreeNode * right = new TreeNode;
	node -> left = left;
	node -> right = right;
	left -> parent = node;
	right -> parent = node; 
	readNewick(in, left, num, n);
      }
      else if(tmp == ':'){
	counter = 0;
	while((tmp != ',') && (tmp != ')')){
	  in >> tmp;
	  if((tmp != ',') && (tmp != ')'))
	    holding2[counter] = tmp;
	  counter++;
	}
	node -> wt = atof(holding2);
	
	if(tmp == ','){
	  if(node -> parent -> right -> wt == -10000)
	    readNewick(in, node -> parent -> right, num, n);
	  else {
	    TreeNode * middle = new TreeNode;
	    node -> parent -> middle = middle;
	    middle -> parent = node;
	    readNewick(in, middle, num, n);
	  }
	}
	//	  readNewick(in, node -> parent -> right, num, n);
	else if(tmp == ')')
	  readNewick(in, node -> parent, num, n);
      }
      else{
	holding[0] = tmp; counter++;
	while(tmp != ':'){
	  in >> tmp;
	  if(tmp != ':')
	    holding[counter] = tmp;
	  counter++;
	} 
	node -> Allocate(holding);
	node -> wt = atof(holding2);
	node -> name = num;
	num++; n++;
	counter = 0; 
	while((tmp != ',') && (tmp != ')')){
	  in >> tmp;
	  if((tmp != ',') && (tmp != ')'))
	    holding2[counter] = tmp;
	  counter++;
	}
	node -> wt = atof(holding2);node -> wt = atof(holding2);
	if(tmp == ','){
	  if(node -> parent -> right -> wt == -10000)
	    readNewick(in, node -> parent -> right, num, n);
	  else {
	    TreeNode * middle = new TreeNode;
	    node -> parent -> middle = middle;
	    middle -> parent = node;
	    readNewick(in, middle, num, n);
	  }
	}
	//if(tmp == ',')
	//  readNewick(in, node -> parent -> right, num, n);
	else if(tmp == ')')
	  readNewick(in, node -> parent, num, n);
      }
//       delete [] holding;
//       delete [] holding2;
    }
  }

  delete [] holding;
  delete [] holding2;
}

void cleanNum(TreeNode* node, int & num){
  if(node != NULL){
      if(node -> wt != -10000){
	if(node -> name == -1)
	  {
	    cleanNum(node -> left, num);
	    if(node -> middle != 0){
	      cleanNum(node -> middle, num);
	    }
	    cleanNum(node -> right, num);
	  }      
	else {
	  node -> name = num;
	  num++;
	}
      }
      else {
	cleanNum(node -> left, num);
	if(node -> middle != 0){
	  cleanNum(node -> middle, num);
	}
	cleanNum(node -> right, num);
      }
    }
}

void assignLeafLevel(TreeNode* node, int & h){
  if(node != NULL){
    if(node -> wt != -10000){
      node -> hight = node -> parent -> hight + 1;
    }
    if(node -> hight > h) h = node -> hight;
      assignLeafLevel(node -> right, h);
      assignLeafLevel(node -> left, h);
  }
}

void countNumber(TreeNode* node, int * data){
  if(node != NULL){
    if(node -> name == -1)
      data[node -> hight]++;
    countNumber(node -> right, data);
    countNumber(node -> left, data);
  }
}

void preAssignNum(TreeNode* node, int * data, int * nodes, int N){
  if(node != NULL){
    if(node -> name != -1){
      node -> num = node -> name;
      nodes[node -> num - 1] = 0;
    }
    else{
      if(node -> wt == -10000){
	node -> num = N;
	nodes[N - 1] = 0;
      }
      else{
	int sum = 0, j = 0;
	for(int i = 0; i < (node -> hight - 1); i++) sum += data[i];
	while(nodes[N - 1 - sum - j] == 0) j++;
	node -> num = N - sum - j;
	nodes[N - 1 - sum - j] = 0;
      }
    }
    preAssignNum(node -> left, data, nodes, N);
    preAssignNum(node -> right, data, nodes, N);
  }
}

void assignNum(TreeNode* node, int h, int n){
  int N = 2 * n - 1;
  int data[h], nodes[N];
  for(int i = 0; i < h; i++) data[i] = 0;
  for(int i = 0; i < N; i++) nodes[i] = 1;
  countNumber(node, data);
  preAssignNum(node, data, nodes, N);

}

void preTreeMatrix(TreeNode* node, int** TreeMatrix){
  if(node != NULL){
    if(node -> name != -1){
      TreeMatrix[node -> num - 1][0] = 1;
      TreeMatrix[node -> num - 1][3] = node -> parent -> num;
    }
    else{
      TreeMatrix[node -> num - 1][1] = node -> left -> num;
      TreeMatrix[node -> num - 1][2] = node -> right -> num;
      if(node -> wt != -10000)
	TreeMatrix[node -> num - 1][3] = node -> parent -> num;
    }
    preTreeMatrix(node -> left, TreeMatrix);
    preTreeMatrix(node -> right, TreeMatrix);
  }
}

void preTreeMatrix(TreeNode* node, int** TreeMatrix, LaVectorDouble & BrLenV){
  if(node != NULL){
    if(node -> name != -1){
      TreeMatrix[node -> num - 1][0] = 1;
      TreeMatrix[node -> num - 1][3] = node -> parent -> num;
      BrLenV(node -> num - 1) = node -> wt;
    }
    else{
      TreeMatrix[node -> num - 1][1] = node -> left -> num;
      TreeMatrix[node -> num - 1][2] = node -> right -> num;
      if(node -> wt != -10000){
	TreeMatrix[node -> num - 1][3] = node -> parent -> num;
	BrLenV(node -> num - 1) = node -> wt;
      }
    }
    preTreeMatrix(node -> left, TreeMatrix, BrLenV);
    preTreeMatrix(node -> right, TreeMatrix, BrLenV);
  }
}



/******** Construct tree matrices for all m-subtrees ******************/

long double getSubtreeWt(int** TreeMatrix, int n, int m, int* lvIndex, 
		       LaVectorDouble Brlen){

  list<int> lvs, parents, newLvs, hold;
  long double wt = 0.0;
  list<int>::iterator nums_iter, nums_iter2, nums_iter3;
  int numLv = (2 * m) - 1, numOfSubtree = Choose(n, m), 
    root = (2 * n) - 1, tmp = 0, left = 0, right = 0;

  for(int i = 0; i < m; i++){
    lvs.push_back(lvIndex[i]); newLvs.push_back(lvIndex[i]);
  }

//   for(nums_iter = lvs.begin(); nums_iter != lvs.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << endl;
//   }
  for(int i = 0; i < m; i++)
    parents.push_back(TreeMatrix[lvIndex[i] - 1][3]);

//   for(int i = 0; i < m; i++) cout << leaves[i] << " ";
//   cout << endl;

//   for(int i = 0; i < (2*n - 1); i++){
//     for(int j = 0; j < 4; j++){
//       cout << TreeMatrix[i][j] << " ";
//     }
//     cout << endl;
//   }cout << endl;

//   for(nums_iter = parents.begin(); nums_iter != parents.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << endl;
//   }

//   exit(0);
  while(!parents.empty()){

    tmp = parents.front();
    //    cout << tmp << endl;
    parents.pop_front();
    
    nums_iter = find(parents.begin(), parents.end(), TreeMatrix[tmp - 1][3]);
    if(nums_iter == parents.end())
      if(TreeMatrix[tmp - 1][3] != 0)
	parents.push_back(TreeMatrix[tmp - 1][3]);
    
    nums_iter = find(lvs.begin(), lvs.end(), tmp);

    if(nums_iter == lvs.end()){
      lvs.push_back(tmp);
    }
  }

  lvs.sort();
//   for(nums_iter = lvs.begin(); nums_iter != lvs.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << endl;
//   }exit(0);

  while(!lvs.empty()){
    tmp = lvs.back();
    //cout << tmp << endl;
    lvs.pop_back(); 
    parents.push_back(tmp);
    left =  TreeMatrix[tmp - 1][1]; //cout << left << endl;
    right =  TreeMatrix[tmp - 1][2];//cout << right << endl; 

    nums_iter2 = find(lvs.begin(), lvs.end(), left);
    nums_iter3 = find(lvs.begin(), lvs.end(), right);
    if((nums_iter2 != lvs.end()) && (nums_iter3 != lvs.end()))
      hold.push_back(tmp);
  }

  hold.sort();

  root = hold.back();
  //    cout << root << endl; exit(0);
  hold.push_front(root);
  parents.sort();

  hold.clear();

  while(!parents.empty()){
    tmp = parents.back();
    //cout << tmp << endl;
    parents.pop_back(); 
    if(tmp <= root){
      left =  TreeMatrix[tmp - 1][1]; //cout << left << endl;
      right =  TreeMatrix[tmp - 1][2];//cout << right << endl << endl;
      nums_iter2 = find(parents.begin(), parents.end(), left);
      nums_iter3 = find(parents.begin(), parents.end(), right);
      if(nums_iter2 != parents.end())
	hold.push_front(tmp);
      if(nums_iter3 != parents.end())
	hold.push_front(tmp);
    }
  }

  while(!hold.empty()){
    tmp = hold.back();
    //cout << tmp << endl;
    hold.pop_back();
    nums_iter = find(newLvs.begin(), newLvs.end(), tmp);
    if(nums_iter == newLvs.end())
      newLvs.push_front(tmp);
  }

  newLvs.sort();
  newLvs.pop_back();
  for(nums_iter = newLvs.begin(); nums_iter != newLvs.end(); nums_iter++)
  {
    wt += Brlen((*nums_iter) - 1);
    //cout << (*nums_iter) << endl;
  }
  //  if(newLvs.back() != (2*n - 1)) wt -= Brlen(newLvs.back() - 1);
  newLvs.clear();

  //cout << wt << endl;
  return wt;
}

void constructSubTree(TreeNode* node, int** TreeMatrix, list<int> lvs, 
		      int num, int & lvNum, LaVectorDouble Brlen)
{
  list<int>::iterator iter, iter2;
  iter = find(lvs.begin(), lvs.end(), TreeMatrix[num - 1][1]);
  if(iter != lvs.end()){
    TreeNode * left = new TreeNode;
    node -> left = left;
    left -> wt = Brlen(TreeMatrix[num - 1][1] - 1);
    left -> parent = node;
    if(TreeMatrix[TreeMatrix[num - 1][1] - 1][0] == 1){
      left -> name = lvNum; lvNum++;
    }
  }
  iter2 = find(lvs.begin(), lvs.end(), TreeMatrix[num - 1][2]);
  if(iter2 != lvs.end()){
    TreeNode * right = new TreeNode;
    node -> right = right;
    right -> wt = Brlen(TreeMatrix[num - 1][2] - 1);
    right -> parent = node;
    if(TreeMatrix[TreeMatrix[num - 1][2] - 1][0] == 1){
      right -> name = lvNum; lvNum++;
    }
  }

  if(node -> left != NULL)
    constructSubTree(node -> left, TreeMatrix, lvs, (*iter), lvNum, Brlen);
  if(node -> right != NULL)
    constructSubTree(node -> right, TreeMatrix, lvs, (*iter2), lvNum, Brlen);

}

void deleteNode(TreeNode* node){
  if(node != NULL){
    TreeNode *temp = node;
    if(node -> right == NULL){
      if(node -> left != NULL){
	node -> left -> wt += node -> wt;
	node  -> left -> parent = node -> parent;
	if(node -> parent -> right == node)
	  node -> parent -> right = node -> left;
	else  node -> parent -> left = node -> left;
	delete temp;      
	deleteNode(node-> left);
      }
    }
    else if(node -> left == NULL){
      if(node -> right != NULL){
	node -> right -> wt += node -> wt;
	node -> right -> parent = node -> parent;
	if(node -> parent -> right == node)
	  node -> parent -> right = node -> right;
	else  node -> parent -> left = node -> right;
        delete temp;       
	deleteNode(node -> right);
      }
    }
    else if((node -> right != NULL) && (node -> left != NULL)){
    deleteNode(node -> left);
    deleteNode(node -> right);
    }
  }
}

void printTree3(TreeNode* node, int number){
  if(node != 0){
    //      node -> printNode();
    printTree3(node -> right, number + 7);
    for(int i = 0; i < number; i++) cout << " ";
    node -> printNode();
    printTree3(node -> left, number + 7);
  }
}


int** subTreeMatrix(int** TreeMatrix, int n, int m, int* leaves, 
		    LaVectorDouble Brlen, LaVectorDouble & newBrlen){
  int **newMatrix; 
  TreeNode* subTree;
  list<int> lvs, parents, bad, good, newLvs;
  list<int>::iterator nums_iter, nums_iter2, nums_iter3;
  int tmp = 0, right = 0, left = 0;

  newMatrix = new int*[2*m - 1];

  for(int i = 0; i < (2*m - 1); i++)
    newMatrix[i] = new int[4]; 

  for(int i = 0; i < (2*m - 1); i++)
    for(int j = 0; j < 4; j++)
      newMatrix[i][j] = 0;

//   for(int i = 0; i < m; i++)
//     for(int j = 0; j < 4; j++)
//       newMatrix[i][j] = TreeMatrix[leaves[i] - 1][j];

  for(int i = 0; i < m; i++){
    lvs.push_back(leaves[i]);
    newLvs.push_back(leaves[i]);
  }

  for(int i = 0; i < m; i++)
    parents.push_back(TreeMatrix[leaves[i] - 1][3]);

//   for(int i = 0; i < m; i++) cout << leaves[i] << " ";
//   cout << endl;

//   for(int i = 0; i < (2*n - 1); i++){
//     for(int j = 0; j < 4; j++){
//       cout << TreeMatrix[i][j] << " ";
//     }
//     cout << endl;
//   }cout << endl;

//   for(nums_iter = parents.begin(); nums_iter != parents.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << endl;
//   }

//   exit(0);
  while(!parents.empty()){

    tmp = parents.front();
    // cout << tmp << endl;
    parents.pop_front();
    nums_iter = find(parents.begin(), parents.end(), TreeMatrix[tmp - 1][3]);
    if(nums_iter == parents.end())
      if(TreeMatrix[tmp - 1][3] != 0)
	parents.push_back(TreeMatrix[tmp - 1][3]);
    left =  TreeMatrix[tmp - 1][1]; //cout << left << endl;
    right =  TreeMatrix[tmp - 1][2];//cout << right << endl;
    nums_iter = find(lvs.begin(), lvs.end(), left);
    nums_iter2 = find(lvs.begin(), lvs.end(), right);
    if((nums_iter != lvs.end()) && (nums_iter2 != lvs.end())){
      nums_iter3 = find(good.begin(), good.end(), tmp);
      if(nums_iter3 == good.end())
	good.push_back(tmp); 
    }
    else {
      nums_iter3 = find(bad.begin(), bad.end(), tmp);
      if(nums_iter3 == bad.end())
	bad.push_back(tmp);
      //     if(tmp == 10) cout << left << " " << right << endl;
    }
    nums_iter3 = find(lvs.begin(), lvs.end(), tmp);
    if(nums_iter3 == lvs.end())
      lvs.push_back(tmp);
  }

  for (nums_iter = good.begin(); nums_iter != good.end(); nums_iter++){
    nums_iter2 = find(bad.begin(), bad.end(), (*nums_iter));
    if(nums_iter2 != bad.end()) bad.erase(nums_iter2);
  }

  for(nums_iter = good.begin(); nums_iter != good.end(); nums_iter++)
    newLvs.push_back((*nums_iter));

//   cout << "Leaves: " << " ";
//   for(nums_iter = lvs.begin(); nums_iter != lvs.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << " ";
//   }cout << endl;
//   //  cout << good.size() << " ";
//   cout << "Good: ";
//   for(nums_iter = good.begin(); nums_iter != good.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << " ";
//   }cout << endl;

//   cout << "Bad: ";
//   for(nums_iter = bad.begin(); nums_iter != bad.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << " ";
//   }cout << endl;

  bad.sort(); newLvs.sort();
  lvs.sort(); good.sort();

//   cout << "Bad: ";
//   for(nums_iter = bad.begin(); nums_iter != bad.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << " ";
//   }cout << endl;

//   cout << "Leaves: " << " ";
//   for(nums_iter = lvs.begin(); nums_iter != lvs.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << " ";
//   }cout << endl;

//   cout << "New Leaves: " << " ";
//   for(nums_iter = newLvs.begin(); nums_iter != newLvs.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << " ";
//   }cout << endl;

  int numOfLvs = newLvs.size(), rootNum = newLvs.back(), lvNum = 1;
  int dim = 0, h = 0;
  subTree = new TreeNode;
  subTree -> num = numOfLvs;
  constructSubTree(subTree, TreeMatrix, lvs, rootNum, lvNum, Brlen);
  //printTree3(subTree, 0);
  deleteNode(subTree); //deleteNode(subTree); 
  //printTree3(subTree, 0);
  assignLeafLevel(subTree, h);
  assignNum(subTree, h, m); // printTree3(subTree, 0);
  preTreeMatrix(subTree, newMatrix, newBrlen);
  bad.clear(); lvs.clear(); good.clear(); newLvs.clear();

//   for(int i = 0; i < (2*m - 1); i++){
//     for(int j = 0; j < 4; j++){
//       cout << newMatrix[i][j] << " ";
//     }
//     cout << endl;
//   }cout << endl; 

//   for(int i = 0; i < (2*m - 2); i++) cout << newBrlen(i) << " ";
//   cout << endl;

  deleteTree(subTree);
  return newMatrix;
}


/******** Print a tree in Newick format ******************************/

void printTreeMatrix(char* file, TreeNode* tree, int N){
  int** TreeMatrix;
  TreeMatrix = new int*[N];
  for(int i = 0; i < N; i++) 
    TreeMatrix[i] = new int[4];
  for(int i = 0; i < N; i++)
    for(int j = 0; j < 4; j++) TreeMatrix[i][j] = 0;
    preTreeMatrix(tree, TreeMatrix);
    ofstream out(file);
    if(!out){
      cerr << "Writing Error!" << endl;
      exit(0);
    }
    for(int i = 0; i < N; i++){
      for(int j = 0; j < 4; j++){
	out << TreeMatrix[i][j] << " ";
      }
      out << endl;
    }out << endl;
}


void printTree2(TreeNode* node, int number){
  if(node != 0){
    //      node -> printNode();
    printTree2(node -> right, number + 7);
    for(int i = 0; i < number; i++) cout << " ";
    node -> printNode();
    printTree2(node -> left, number + 7);
  }
}

void DFS3(TreeNode* node){
  if(node != 0){
      if(node -> wt != -10000){
	if(node -> name == -1)
	  {
	    cout << "(";
	    DFS3(node -> left);
	    cout << ",";
	    if(node -> middle != 0){
	      DFS3(node -> middle);
	      cout << ",";
	    }
	    DFS3(node -> right);
	    cout << ")";
	    cout << ":";
	    cout << fixed << node -> wt;
	  }      
	else {
	  cout << node -> name;
	  cout << ":";
	  cout << fixed << node -> wt;
	}
      }
      else {
	cout << "(";
	DFS3(node -> left);
	cout << ",";
	if(node -> middle != 0){
	  DFS3(node -> middle);
	  cout << ",";
	}
	DFS3(node -> right);
	cout << ");" << endl;
      }
    }
}


void printDND2(TreeNode* node, ofstream & out){
  if(node != 0){
    if(node -> wt != -10000){
      if(node -> name == -1)
	{
	  out << "(";
	  printDND2(node -> left, out);
	  out << ",";
	  printDND2(node -> right, out);
	    out << ")";
	    out << ":";
	    out << fixed << node -> wt;
	}      
      else {
	out << node -> RealName;
	out << ":";
	out << fixed << node -> wt;
      }
    }
    else {
      out << "(";
      printDND2(node -> left, out);
      out << ",";
      printDND2(node -> right, out);
      out << ");" << endl;
    }
  }
}


void printDND3(TreeNode* node){
  if(node != 0){
    if(node -> wt != -10000){
      if(node -> name == -1)
	{
	  cout << "(";
	  printDND3(node -> left);
	  cout << ",";
	  printDND3(node -> right);
	    cout << ")";
	    cout << ":";
	    cout << fixed << node -> wt;
	}      
      else {
	cout << node -> RealName;
	cout << ":";
	cout << fixed << node -> wt;
      }
    }
    else {
      cout << "(";
      printDND3(node -> left);
      cout << ",";
      printDND3(node -> right);
      cout << ");" << endl;
    }
  }
}

void writeTreeMatrix(int argc, char *argv[]){
  TreeNode* tree;

  int num = 1, m = 2, n = 0, dim = 0, h = 0;
  char filename[200], output[200], tmpFile[200], file[200];
  cout << "Running ReadNewick v0.9" << endl;
  strcpy(filename, argv[argc - 1]);
  strcpy(output, "no");

  for(int f = 0; f < argc; f++){
    if(strncmp(argv[f], "-o", 2) == 0){
      if(argv[f + 1] == NULL)
	{
	cerr << "Error: Please inter the output file name." << endl;
	exit(0);
      }
      else   strcpy(tmpFile, argv[f + 1]);
      strcpy(output, "yes");
    }
  }

  if(output[0] == 'y') {
    strcpy(file, tmpFile);
    strcat(file, ".mat");
  }
  else     strcpy(file, "tree.mat");

  ifstream in(filename);
  tree = new TreeNode;
  readNewick(in, tree, num, n);
  dim = 2 * n - 1;
  cout << "\nPhylogenetic tree is: " << endl;
  assignLeafLevel(tree, h);
  ofstream tmp("tmp");
  printDND2(tree, tmp); 
  assignNum(tree, h, n);
  //  printTree(tree, 0);
  printTreeMatrix(file, tree, dim);
}

void TreeMatrixfun(int** TreeMatrix, TreeNode* tree, int N, 
		LaVectorDouble & BrLenV){
  for(int i = 0; i < N; i++)
    for(int j = 0; j < 4; j++) TreeMatrix[i][j] = 0;
  preTreeMatrix(tree, TreeMatrix, BrLenV);
}

TreeNode* copy( TreeNode* node, TreeNode * parent)
{
   if(!node) return 0;
   else{
     TreeNode* cp = new TreeNode;
     if(node -> name != -1)
       cp -> Allocate(node -> RealName);
     cp -> name = node -> name;
     cp -> wt = node -> wt;
     cp -> parent = parent;
     cp -> left = copy(node -> left, cp);
     cp -> right = copy(node -> right, cp);
     return cp;
   }
}

int** writeTreeMatrix(char* filename, char* newick, int & n, 
		      LaVectorDouble & BrLenV, Alinements ** InputData){
  TreeNode* tree;
  int** TreeMat;
  int num = 1, m = 2, dim = 0, h = 0;
  double tfreq = 0.0, cfreq = 0.0, afreq = 0.0, gfreq = 0.0, trans = 0.0;
  char freq[127], TsTv[127];
  strcpy(freq, "no");
  strcpy(TsTv, "no");

  ifstream in(filename);
  tree = new TreeNode;
  if(newick[0] == 'y'){
    readNewick(in, tree, num, n); 
  }
  else{
    tree = copy(MJOIN(n, m, filename, freq, TsTv, tfreq, cfreq, afreq, gfreq, trans, InputData), tree);
  cleanNum(tree, num);
  }

  dim = 2 * n - 1; 
  BrLenV.resize(dim - 1, 1); 
  for(int i = 0; i < (dim - 1); i++) BrLenV(i) = 0.0; 
  TreeMat = new int*[dim];
  for(int i = 0; i < dim; i++) 
    TreeMat[i] = new int[4];
  
  assignLeafLevel(tree, h);
  assignNum(tree, h, n);

  TreeMatrixfun(TreeMat, tree, dim, BrLenV);

  return TreeMat;
}

int** writeTreeMatrix(char* filename, char* newick, int & n, 
		      LaVectorDouble & BrLenV, Alinements ** InputData,
		      double & tfreq, double & cfreq, double & afreq, 
		      double & gfreq, char* freq, char* TsTv){
  TreeNode* tree;
  int** TreeMat;
  int num = 1, m = 2, dim = 0, h = 0;
  //  double tfreq = 0.0, cfreq = 0.0, afreq = 0.0, gfreq = 0.0,
  double trans = 0.5;
  //cout << freq << " " << TsTv << endl;

  ifstream in(filename);
  tree = new TreeNode;
  if(newick[0] == 'y'){
    readNewick(in, tree, num, n); 
  }
  else{
    tree = copy(MJOIN(n, m, filename, freq, TsTv, tfreq, cfreq, afreq, gfreq, trans, InputData), tree);
  cleanNum(tree, num);
  }
  // cout << afreq << " " << gfreq << " " <<  tfreq<< " " << cfreq << endl;
  dim = 2 * n - 1; 
  BrLenV.resize(dim - 1, 1); 
  for(int i = 0; i < (dim - 1); i++) BrLenV(i) = 0.0; 
  TreeMat = new int*[dim];
  for(int i = 0; i < dim; i++) 
    TreeMat[i] = new int[4];
  
  assignLeafLevel(tree, h);
  assignNum(tree, h, n);

  TreeMatrixfun(TreeMat, tree, dim, BrLenV);

  return TreeMat;
}

int** writeTreeMatrix(char* filename, char* newick, int & n, int m,
		      LaVectorDouble & BrLenV, Alinements ** InputData,
		      double & tfreq, double & cfreq, double & afreq, 
		      double & gfreq, char* freq, char* TsTv){
  TreeNode* tree;
  int** TreeMat;
  int num = 1, dim = 0, h = 0;
  //  double tfreq = 0.0, cfreq = 0.0, afreq = 0.0, gfreq = 0.0,
  double trans = 0.5;
  //cout << freq << " " << TsTv << endl;

  ifstream in(filename);
  tree = new TreeNode;
  if(newick[0] == 'y'){
    readNewick(in, tree, num, n); 
  }
  else{
    tree = copy(MJOIN(n, m, filename, freq, TsTv, tfreq, cfreq, afreq, gfreq, trans, InputData), tree);
  cleanNum(tree, num);
  }
  // cout << afreq << " " << gfreq << " " <<  tfreq<< " " << cfreq << endl;
  dim = 2 * n - 1; 
  BrLenV.resize(dim - 1, 1); 
  for(int i = 0; i < (dim - 1); i++) BrLenV(i) = 0.0; 
  TreeMat = new int*[dim];
  for(int i = 0; i < dim; i++) 
    TreeMat[i] = new int[4];
  
  assignLeafLevel(tree, h);
  assignNum(tree, h, n);

  TreeMatrixfun(TreeMat, tree, dim, BrLenV);
  deleteTree(tree);

  return TreeMat;
}

int** writeTreeMatrix(char* filename, char* newick, int & n, int m,
		      LaVectorDouble & BrLenV, Alinements ** InputData,
		      double & tfreq, double & cfreq, double & afreq, 
		      double & gfreq, char* freq, char* TsTv, 
		      char *** listOfNames){
  TreeNode* tree;
  int** TreeMat;
  int num = 1, dim = 0, h = 0;
  //  double tfreq = 0.0, cfreq = 0.0, afreq = 0.0, gfreq = 0.0,
  double trans = 0.5;
  //cout << freq << " " << TsTv << endl;

  ifstream in(filename);
  tree = new TreeNode;
  if(newick[0] == 'y'){
    readNewick(in, tree, num, n); 
  }
  else{
    tree = copy(MJOIN(n, m, filename, freq, TsTv, tfreq, cfreq, afreq, gfreq, trans, InputData), tree);
  cleanNum(tree, num);
  }
  (*listOfNames) = new char*[n];

  // for(int i = 0; i < n; i++) cout << (*listOfNames)[i] << endl;
  // cout << afreq << " " << gfreq << " " <<  tfreq<< " " << cfreq << endl;
  dim = 2 * n - 1; 
  BrLenV.resize(dim - 1, 1); 
  for(int i = 0; i < (dim - 1); i++) BrLenV(i) = 0.0; 
  TreeMat = new int*[dim];
  for(int i = 0; i < dim; i++) 
    TreeMat[i] = new int[4];
  
  assignLeafLevel(tree, h);
  assignNum(tree, h, n);
  getListOfNames((*listOfNames), tree);
  TreeMatrixfun(TreeMat, tree, dim, BrLenV);

  ofstream TreeFile;
  TreeFile.open("initial.dnd");
  printDND2(tree, TreeFile);
  cout << "The initial tree is: " << endl;
  printDND3(tree);
  cout << endl;
  deleteTree(tree);

  return TreeMat;
}


void ChnageNum(TreeNode* node, const char* a, int index){
  if(node != NULL){
    if(node -> name != -1){
      // cout << a << " " << node -> RealName << " " << node -> num << " " << strcmp(node -> RealName, a) << endl;
      if(strcmp(node -> RealName, a) == 0){
	node -> num = index;
	node -> name = index;
      }
    }
    ChnageNum(node -> left, a, index);
    ChnageNum(node -> right, a, index);
  }
}

void readAlignment(char* filename, Alinements ** InputData){
   int counter = 0, num = 0, n = 0;
   string tmpString;

    char jnk = 'a';
    ifstream Counter(filename);
    
    if(!Counter){
      cerr << "Input file is missing!!  Please check input file." << endl;
      exit(0);
    }
    
    // cout << "Reading the input file...";
    while(!Counter.eof()){
      Counter >> tmpString;
      if(tmpString[0] == '>') n++; 
    }
    
    ifstream in(filename);
    
    *InputData = new Alinements[n];
    for(int i = 0; i < n; i++){
      in >> jnk; 
      if(jnk == '>') {
	in >> (*InputData)[counter].name; 
      }
      jnk = 'a';
      while(jnk != '>'){
	if(jnk != 'a')     in.putback(jnk);
	if(in.eof()) jnk = '>';
	in >> tmpString; 
	if(jnk != '>')
	  (*InputData)[counter].DNA.append(tmpString);
	in >> jnk;
      }
      counter++;
      (*InputData)[counter - 1].number = counter;
      in.putback(jnk);
    }    
}


/* This writeTreeMatrix is currently used.....  So many of them.... :( */

int** writeTreeMatrix(char* filename, char* newick, int & n, int m,
		      LaVectorDouble & BrLenV, Alinements ** InputData,
		      double & tfreq, double & cfreq, double & afreq, 
		      double & gfreq, char* freq, char* TsTv, double trans,
		      char *** listOfNames, char* AlignFile){
  TreeNode* tree;
  int** TreeMat;
  int num = 1, dim = 0, h = 0;
  //  double tfreq = 0.0, cfreq = 0.0, afreq = 0.0, gfreq = 0.0,
  //double trans = 0.5;
  //cout << freq << " " << TsTv << endl;
  ifstream in(filename);
  tree = new TreeNode;
  if(newick[0] == 'y'){
    readNewick(in, tree, num, n); 
    //    cout << "Please enter the table file name...." << endl;
    // char TableFile[200], AlignFile[200];
    string TmpSt;
    (*listOfNames) = new char*[n];
    //cin >> TableFile;
//     ifstream in2(TableFile);
//     if(!in2){
//       cerr << "No such a file!" << endl;
//       exit(0);
//     }
//     for(int i = 0; i < n; i++){
//       in2 >> TmpSt;
//       (*listOfNames)[i] = new char[strlen(TmpSt.c_str()) + 1];
//       strcpy((*listOfNames)[i], TmpSt.c_str());
//       ChnageNum(tree, TmpSt.c_str(), i + 1);
//     }
    //    cout << "Please enter the alignment file name...." << endl;
    //cin >> AlignFile;
    readAlignment(AlignFile, InputData);
    for(int i = 0; i < n; i++){
      (*listOfNames)[i] = new char[strlen((*InputData)[i].name) + 1];
      strcpy((*listOfNames)[i], (*InputData)[i].name);
      ChnageNum(tree, (*InputData)[i].name, i + 1);
    }

    removeDash(InputData, n);
  }
  else{
    tree = copy(MJOIN(n, m, filename, freq, TsTv, tfreq, cfreq, afreq, gfreq, trans, InputData), tree);
  cleanNum(tree, num);
  //  }
  (*listOfNames) = new char*[n];
  }

//   for(int i = 0; i < n; i++) cout << (*listOfNames)[i] << endl;
//   cout << afreq << " " << gfreq << " " <<  tfreq<< " " << cfreq << endl;
  dim = 2 * n - 1; 
  BrLenV.resize(dim - 1, 1); 
  for(int i = 0; i < (dim - 1); i++) BrLenV(i) = 0.0; 
  TreeMat = new int*[dim];
  for(int i = 0; i < dim; i++) 
    TreeMat[i] = new int[4];
  
  assignLeafLevel(tree, h);
  assignNum(tree, h, n);
  if(newick[0] == 'n')
    getListOfNames((*listOfNames), tree);
  TreeMatrixfun(TreeMat, tree, dim, BrLenV);

  ofstream TreeFile;
  TreeFile.open("initial.dnd");
  printDND2(tree, TreeFile);
  cout << "The initial tree is: " << endl;
  printDND3(tree);
  cout << endl;
  //  printTree3(tree, 0);
  deleteTree(tree);

  return TreeMat;
}

int** writeTreeMatrix(char* filename, char* newick, int & n, int m,
		      LaVectorDouble & BrLenV, Alinements ** InputData,
		      double & tfreq, double & cfreq, double & afreq, 
		      double & gfreq, char* freq, char* TsTv, double trans,
		      char *** listOfNames){
  TreeNode* tree;
  int** TreeMat;
  int num = 1, dim = 0, h = 0;
  //  double tfreq = 0.0, cfreq = 0.0, afreq = 0.0, gfreq = 0.0,
  //double trans = 0.5;
  //cout << freq << " " << TsTv << endl;
  ifstream in(filename);
  tree = new TreeNode;
  if(newick[0] == 'y'){
    readNewick(in, tree, num, n); 
    cout << "Please enter the table file name...." << endl;
    char TableFile[200], AlignFile[200];
    string TmpSt;
    (*listOfNames) = new char*[n];
    cin >> TableFile;
    ifstream in2(TableFile);
    if(!in2){
      cerr << "No such a file!" << endl;
      exit(0);
    }
    for(int i = 0; i < n; i++){
      in2 >> TmpSt;
      (*listOfNames)[i] = new char[strlen(TmpSt.c_str()) + 1];
      strcpy((*listOfNames)[i], TmpSt.c_str());
      ChnageNum(tree, TmpSt.c_str(), i + 1);
    }
    cout << "Please enter the alignment file name...." << endl;
    cin >> AlignFile;
    readAlignment(AlignFile, InputData);
    removeDash(InputData, n);
  }
  else{
    tree = copy(MJOIN(n, m, filename, freq, TsTv, tfreq, cfreq, afreq, gfreq, trans, InputData), tree);
  cleanNum(tree, num);
  //  }
  (*listOfNames) = new char*[n];
  }

//   for(int i = 0; i < n; i++) cout << (*listOfNames)[i] << endl;
//   cout << afreq << " " << gfreq << " " <<  tfreq<< " " << cfreq << endl;
  dim = 2 * n - 1; 
  BrLenV.resize(dim - 1, 1); 
  for(int i = 0; i < (dim - 1); i++) BrLenV(i) = 0.0; 
  TreeMat = new int*[dim];
  for(int i = 0; i < dim; i++) 
    TreeMat[i] = new int[4];
  
  assignLeafLevel(tree, h);
  assignNum(tree, h, n);
  if(newick[0] == 'n')
    getListOfNames((*listOfNames), tree);
  TreeMatrixfun(TreeMat, tree, dim, BrLenV);

  ofstream TreeFile;
  TreeFile.open("initial.dnd");
  printDND2(tree, TreeFile);
  cout << "The initial tree is: " << endl;
  printDND3(tree);
  cout << endl;
  //  printTree3(tree, 0);
  deleteTree(tree);

  return TreeMat;
}

int** writeTreeMatrix(char* filename, char* newick, int & n, int m,
		      LaVectorDouble & BrLenV, Alinements ** InputData,
		      double & tfreq, double & cfreq, double & afreq, 
		      double & gfreq, char* freq, char* TsTv, double trans,
		      char *** listOfNames, int ***SeqMat, int & SeqLen,
		      int numSt){
  TreeNode* tree;
  int** TreeMat;
  int num = 1, dim = 0, h = 0;
  //  double tfreq = 0.0, cfreq = 0.0, afreq = 0.0, gfreq = 0.0,
  //double trans = 0.5;
  //cout << freq << " " << TsTv << endl;

  ifstream in(filename);
  tree = new TreeNode;
  if(newick[0] == 'y'){
    readNewick(in, tree, num, n); 
  }
  else{
    tree = copy(MJOIN(n, m, filename, freq, TsTv, tfreq, cfreq, afreq, gfreq, trans, InputData, SeqMat, SeqLen, numSt), tree);
  cleanNum(tree, num);
  }
  (*listOfNames) = new char*[n];

  // for(int i = 0; i < n; i++) cout << (*listOfNames)[i] << endl;
  // cout << afreq << " " << gfreq << " " <<  tfreq<< " " << cfreq << endl;
  dim = 2 * n - 1; 
  BrLenV.resize(dim - 1, 1); 
  for(int i = 0; i < (dim - 1); i++) BrLenV(i) = 0.0; 
  TreeMat = new int*[dim];
  for(int i = 0; i < dim; i++) 
    TreeMat[i] = new int[4];
  
  assignLeafLevel(tree, h);
  assignNum(tree, h, n);
  getListOfNames((*listOfNames), tree);
  TreeMatrixfun(TreeMat, tree, dim, BrLenV);

  ofstream TreeFile;
  TreeFile.open("initial.dnd");
  printDND2(tree, TreeFile);
  
  cout << "The initial tree is: " << endl;
  printDND3(tree);
  cout << endl;
  // printTree3(tree, 0);
  deleteTree(tree);
  return TreeMat;
}

void MatrixToTree(int n, int** PhylMat, TreeNode* node, int  counter, 
		  LaVectorDouble & BrLenV, char ** listOfNames){
  //cout << counter << endl;
  if(counter > -1){
    if(PhylMat[counter][0] == 0){
      TreeNode * left = new TreeNode;
      TreeNode * right = new TreeNode;
      if(counter != (2 * n - 2))
	node -> wt = BrLenV(counter);
      node -> left = left;
      node -> right = right;
      left -> parent = node;
      right -> parent = node; 
      MatrixToTree(n, PhylMat, node -> left, PhylMat[counter][1] - 1, BrLenV, listOfNames);
      MatrixToTree(n, PhylMat, node -> right, PhylMat[counter][2] - 1, BrLenV, listOfNames);
    }
    else if(PhylMat[counter][0] == 1){
      node -> wt = BrLenV(counter);
      node -> RealName = listOfNames[counter]; 
      node -> name = counter + 1;
    }
  }
}
