/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    November 9th, 2005
 Update:  February 5th, 2006
 Program: This is software for the EMGNJ method with Asger Hobolth.

********************************************************************/

#ifndef NEWICK__H
#define NEWICK__H
#include <iostream>
#include <lapack++.h>
#include <lapack.h>
#include <lafnames.h>
#include <list>

#include "Reading.h"

using namespace std;

long double getSubtreeWt(int** TreeMatrix, int n, int m, int* lvIndex,
			  LaVectorDouble Brlen);
void getListOfNames(char** listOfNames, TreeNode * tree);
void readNewick(ifstream & in, TreeNode * node, int & num, int & n);
void DFS3(TreeNode* node);
void printDND2(TreeNode* node, ofstream & out);
void printDND3(TreeNode* node);
void assignLeafLevel(TreeNode* node, int & h);
void assignNum(TreeNode* node, int h, int n);
void printTree(TreeNode* node, int number);
void printTreeMatrix(char* file, TreeNode* tree, int N);
void writeTreeMatrix(int argc, char *argv[]);
void preTreeMatrix(TreeNode* node, int** TreeMatrix);
void preTreeMatrix(TreeNode* node, int** TreeMatrix, LaVectorDouble & BrLenV);
int** writeTreeMatrix(char* filename, char* newick, int& n,  
		      LaVectorDouble & BrLenV, Alinements ** InputData);
int** subTreeMatrix(int** TreeMatrix, int n, int m, int* leaves, 
		    LaVectorDouble Brlen, LaVectorDouble & newBrlen);
int** writeTreeMatrix(char* filename, char* newick, int & n, 
		      LaVectorDouble & BrLenV, Alinements ** InputData,
		      double & tfreq, double & cfreq, double & afreq, 
		      double & gfreq, char* freq, char* TsTv);
void cleanNum(TreeNode* node, int & num);
void TreeMatrixfun(int** TreeMatrix, TreeNode* tree, int N, 
		LaVectorDouble & BrLenV);
int** writeTreeMatrix(char* filename, char* newick, int & n, int m,
		      LaVectorDouble & BrLenV, Alinements ** InputData,
		      double & tfreq, double & cfreq, double & afreq, 
		      double & gfreq, char* freq, char* TsTv);

int** writeTreeMatrix(char* filename, char* newick, int & n, int m,
		      LaVectorDouble & BrLenV, Alinements ** InputData,
		      double & tfreq, double & cfreq, double & afreq, 
		      double & gfreq, char* freq, char* TsTv, 
		      char *** listOfNames);

int** writeTreeMatrix(char* filename, char* newick, int & n, int m,
		      LaVectorDouble & BrLenV, Alinements ** InputData,
		      double & tfreq, double & cfreq, double & afreq, 
		      double & gfreq, char* freq, char* TsTv, double trans,
		      char *** listOfNames);

int** writeTreeMatrix(char* filename, char* newick, int & n, int m,
		      LaVectorDouble & BrLenV, Alinements ** InputData,
		      double & tfreq, double & cfreq, double & afreq, 
		      double & gfreq, char* freq, char* TsTv, double trans,
		      char *** listOfNames, char* AlignFile);

int** writeTreeMatrix(char* filename, char* newick, int & n, int m,
		      LaVectorDouble & BrLenV, Alinements ** InputData,
		      double & tfreq, double & cfreq, double & afreq, 
		      double & gfreq, char* freq, char* TsTv, double trans,
		      char *** listOfNames, int ***SeqMat, int & SeqLen,
		      int numSt);

TreeNode* copy( TreeNode* node, TreeNode * parent);
void MatrixToTree(int n, int** PhylMat, TreeNode* node, int counter, 
		  LaVectorDouble & BrLenV, char ** listOfNames);
#endif

