/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    March 8th, 2004
 Update:  February 24th, 2005
 
***********************************************************************/
#ifndef READING__H
#define READING__H

#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <string>
#include <math.h>
#include <algorithm>
#include <time.h>

#include "Taxa.h"

using namespace std;

class Alinements{
 public:
  char* name;
  int number;
  string DNA;

  Alinements(){
    number = 0;
    name = new char[127];
  }

  ~Alinements(){
    DNA.erase();
    delete [] name; 
  }

};

void checkMfaFile(char* filename);

void ReadFMAFile(int & n, int & m, char* filename);

void ReadFMAFileNJ(int & n, int & m, char* filename);

void ReadFMAFileNJ2(int & n, int & m, char* filename);


void ReadFMAFileNJ3(int & n, int & m, char* filename, char* freq, char* TsTv, 
                    double tfreq, double cfreq, double afreq, double gfreq, 
		    double trans);

void ReadFMAFileNJ4(int & n, int & m, char* filename, char* freq, char* TsTv, 
                    double &tfreq, double &cfreq, double &afreq, double &gfreq,
		    double trans, Alinements** InputData);

void ReadFMAFile2(int & n, int & m, char* filename);

void ReadTaxa(Taxa * Data, int n, int m, int numOfWeights, ifstream & in, char** names);

void ReadTaxaNJ(Taxa * Data, int n, int m, int numOfWeights, ifstream & in, char** names);

void ReadTaxaNJ2(Taxa * Data, int n, int m, long long int numOfWeights, ifstream & in, char** names);

void ReadPhylFile(int & n, int & m, char* filename);

int getList3(int N, int M, int** out);

void computeIniTreeforEMGNJ(int n, int m, char* freq, 
			   char* TsTv, double &tfreq, double &cfreq, 
			   double &afreq, double &gfreq, double trans,
			    Alinements ** InputData);

void ReadFMAFileNJforEMGNJ(int & n, int & m, char* filename, 
			   Alinements ** InputData);

#endif
