/*********************************************************************

 Author:  Ruriko Yoshida
 Date:    November 25th, 2003
 Update:  January 19th, 2004
 Program: This is a header file for CPU time.

********************************************************************/
#ifndef TIMER_H
#define TIMER_H

#include <time.h>
#include <iostream>
#include <fstream.h>

using namespace std;

class Timer{
  clock_t count;
 public:

  Timer(){
    count = clock();
  }

  void reset(){
    count = clock();
  }
  double GetTime(){
    return double(clock() - count)/CLOCKS_PER_SEC;
  }

  ~Timer(){
    ofstream out;
    out.open("time.out");
    if(!out){
      cerr << "Error on writing CPUTime!" << endl;
      exit(0);
    }
    out <<  GetTime() << endl;
    cout << "CPUTime: " << GetTime() << endl << endl;
  }
};

#endif
