/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    March 14th, 2006
 Update:  March 15th, 2006
 
***********************************************************************/
#ifndef CMPRESSED__H
#define CMPRESSED__H

#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <string>
#include <math.h>
#include <algorithm>
#include <time.h>

#include "Reading.h"
#include "Seq.h"

using namespace std;

class SitePattern{
 public:
  int *site;
  int numOfTaxa;
  int num;
  SitePattern(){
    num = 1;
    numOfTaxa = 0;
  }
  ~SitePattern(){
    delete [] site;
  }

  void clear(){
    delete [] site;
  }

 void Allocate(int n){
    numOfTaxa = n;
    site = new int[n];
  }

 SitePattern operator=(const SitePattern& op1){
   Allocate(op1.numOfTaxa);
   for(int i = 0; i < op1.numOfTaxa; i++)
     site[i] = op1.site[i];
   num = op1.num;
   return *this;
 }
 bool operator==(const SitePattern& S){
   int ini = 0;
   for(int i = 0; i < numOfTaxa; i++)
     if((site[i] - S.site[i]) != 0){
       return 1;
     }
   return 0;
 }

 bool operator<(const SitePattern& S){
   int ini = 0;
   for(int i = 0; i < numOfTaxa; i++)
     if((site[i] - S.site[i]) != 0){
       ini = site[i] - S.site[i];
       if(ini < 0) { return 0;}
       else return 1;
     }
   return 1;
 }

 bool operator>(const SitePattern& S){
   int ini = 0;
   for(int i = 0; i < numOfTaxa; i++)
     if((site[i] - S.site[i]) != 0){
       ini = site[i] - S.site[i];
       if(ini > 0) { return 0;}
       else return 1;
     }
   return 1;
 }

 bool operator<(const int* S){
   int ini = 0;
   for(int i = 0; i < numOfTaxa; i++)
     if((site[i] - S[i]) != 0){
       ini = site[i] - S[i];
       if(ini < 0) { return 0;}
       else return 1;
     }
   return 1;
 }

 bool operator>(const int* S){
   int ini = 0;
   for(int i = 0; i < numOfTaxa; i++)
     if((site[i] - S[i]) != 0){
       ini = site[i] - S[i];
       if(ini > 0) { return 0;}
       else return 1;
     }
   return 1;
 }
 bool operator==(const int* S){
   int ini = 0;
   for(int i = 0; i < numOfTaxa; i++)
     if((site[i] - S[i]) != 0){
       return 1;
     }
   return 0;
 }
 bool Less(const int* S){
   int ini = 0;
   for(int i = 0; i < numOfTaxa; i++)
     if((site[i] - S[i]) != 0){
       ini = site[i] - S[i];
       if(ini < 0) { return 0;}
       else return 1;
     }
   return 1;
 }

 bool Greater(const int* S){
   int ini = 0;
   for(int i = 0; i < numOfTaxa; i++)
     if((site[i] - S[i]) != 0){
       ini = site[i] - S[i];
       if(ini > 0) { return 0;}
       else return 1;
     }
   return 1;
 }
 bool Equal(const int* S){
   int ini = 0;
   for(int i = 0; i < numOfTaxa; i++)
     if((site[i] - S[i]) != 0){
       return 1;
     }
   return 0;

 }

};


class SiteNode{
 public:
  SitePattern node;
  SiteNode *left, *right, *parent;
  SiteNode(){
    parent = 0;
    left = 0;
    right = 0;
  }
  SiteNode(const SitePattern & el, SiteNode *l = 0, SiteNode *r = 0, 
	   SiteNode *p = 0){
    node.Allocate(el.numOfTaxa);
    for(int i = 0; i < el.numOfTaxa; i++)
      node.site[i] = el.site[i];
    node.num = el.num;
/*     cout << "assign:" << endl; */
/*     for(int j = 0; j < el.numOfTaxa; j++) */
/*       cout << node.site[j] <<" "; */
/*     cout <<  endl; */
/*     for(int j = 0; j < el.numOfTaxa; j++) */
/*       cout << el.site[j] <<" "; */
/*     cout <<  endl; */
/*     cout << node.Equal(el.site) << endl; */
    left = l; right = r; parent = p;
  }
  void set(const SitePattern & el){
     node.Allocate(el.numOfTaxa);
    for(int i = 0; i < el.numOfTaxa; i++)
      node.site[i] = el.site[i];
    node.num = el.num;
  }
};

class BST{
public:
    BST() {
        root = 0;
    }
    ~BST() {
        clear();
    }
    void clear() {
        clear(root); root = 0;
    }
    void preorder() {
        preorder(root);
    }
    void inorder() {
        inorder(root);
    }
    void postorder() {
        postorder(root);
    }
    int sum() {
      int total = 0;
      sum(root, total);
      return total;
    }
    int numOfNodes() {
      int total = 0;
      numOfNodes(root, total);
      return total;
    }
    void setMatrix(int** Mat){
      int index = 0;
      setMatrix(root, Mat, index);
    }
    void insert(const SitePattern&);
    SitePattern* search(const SitePattern& el) const {
        return search(root,el);
    }
protected:
    SiteNode* root;
    void clear(SiteNode*);
    SitePattern* search(SiteNode*, const SitePattern&) const;
    void preorder(SiteNode*);
    void inorder(SiteNode*);
    void postorder(SiteNode*);
    void sum(SiteNode*, int&);
    void numOfNodes(SiteNode* p, int & total);
    void setMatrix(SiteNode* p, int** total, int & index);
    virtual void visit(SiteNode* p) {
      for(int i = 0; i < p->node.numOfTaxa; i++)
        cout << p->node.site[i] << ' ';
      cout << endl;
    }
};

/* void BST::clear(SiteNode *p) { */
/*     if (p != 0) { */
/*          clear(p->left); */
/*          clear(p->right); */
/* 	 // p->node.clear(); */
/*          delete p; */
/*      } */
/* } */

/* void BST::insert(const SitePattern& el) { */
/*     SiteNode *p = root, *prev = 0; */
/*     while (p != 0) {        // find a place for inserting new node; */
/*         prev = p; */
/* 	if((p->node.Equal(el.site)) == 0){ */
/* 	   break; */
/* 	} */
/*         if ((p->node.Less(el.site)) == 0) */
/*              p = p->right; */
/*         else  p = p->left; */
/*     } */
/*     if (root == 0){    // tree is empty; */
/*          root = new SiteNode(el); */
/*     } */
/*     else if ((prev->node.Equal(el.site)) == 0) { */
/*       prev->node.num++; */
/* /\*       cout << "=" << endl; *\/ */
/* /\*       for(int j = 0; j < el.numOfTaxa; j++) *\/ */
/* /\* 	cout << prev->node.site[j] <<" "; *\/ */
/* /\*       cout <<  endl; *\/ */
/* /\*       for(int j = 0; j < el.numOfTaxa; j++) *\/ */
/* /\* 	cout << el.site[j] <<" "; *\/ */
/* /\*       cout <<  endl; *\/ */
/*     } */
/*     else if ((prev->node.Less(el.site)) == 0){ */
/*       prev->right = new SiteNode(el); */
/*       prev->right->parent = prev; */
/* /\*       cout << "<" << endl; *\/ */
/* /\*       for(int j = 0; j < el.numOfTaxa; j++) *\/ */
/* /\* 	cout << prev->node.site[j] <<" "; *\/ */
/* /\*       cout <<  endl; *\/ */
/* /\*       for(int j = 0; j < el.numOfTaxa; j++) *\/ */
/* /\* 	cout << el.site[j] <<" "; *\/ */
/* /\*       cout <<  endl; *\/ */
/*     } */
/*     else if ((prev->node.Greater(el.site)) == 0){ */
/*       prev->left  = new SiteNode(el); */
/*       prev->left->parent = prev; */
/* /\*       cout << ">" << endl; *\/ */
/* /\*       for(int j = 0; j < el.numOfTaxa; j++) *\/ */
/* /\* 	cout << prev->node.site[j] <<" "; *\/ */
/* /\*       cout <<  endl; *\/ */
/* /\*       for(int j = 0; j < el.numOfTaxa; j++) *\/ */
/* /\* 	cout << el.site[j] <<" "; *\/ */
/* /\*       cout <<  endl; *\/ */
/*     } */
/*     else if (prev->parent != 0) */
/*       if((prev->parent->node.Equal(el.site)) == 0) { */
/* 	prev->node.num++; */
/*       } */

/*     else cout << "Error." << endl; */
/* } */


/* SitePattern* BST::search(SiteNode* p, const SitePattern& el) const { */
/*     while (p != 0) */
/*         if (p->node == el) */
/*              return &p->node; */
/*         else if (p->node > el) */
/*              p = p->left; */
/*         else p = p->right; */
/*     return 0; */
/* } */

/* void BST::inorder(SiteNode *p) { */
/*      if (p != 0) { */
/*          inorder(p->left); */
/*          visit(p); */
/*          inorder(p->right); */
/*      } */
/* } */

/* void BST::preorder(SiteNode *p) { */
/*     if (p != 0) { */
/*         visit(p); */
/*         preorder(p->left); */
/*         preorder(p->right); */
/*     } */
/* } */

/* void BST::postorder(SiteNode* p) { */
/*     if (p != 0) { */
/*         postorder(p->left); */
/*         postorder(p->right); */
/*         visit(p); */
/*     } */
/* } */

/* void BST::sum(SiteNode* p, int & total) { */
/*     if (p != 0) { */
/*         sum(p->left, total); */
/*         sum(p->right, total); */
/*         total += p->node.num; */
/*     } */
/* } */

/* void BST::numOfNodes(SiteNode* p, int & total) { */
/*     if (p != 0) { */
/*         numOfNodes(p->left, total); */
/*         numOfNodes(p->right, total); */
/*         total++; */
/*     } */
/* } */

/* void BST::setMatrix(SiteNode* p, int** total, int & index) { */
/*     if (p != 0) { */
/*         setMatrix(p->left, total, index); */
/*         setMatrix(p->right, total, index); */
/* 	for(int i = 0; i < p->node.numOfTaxa; i++) */
/* 	  total[i][index] = p->node.site[i]; */
/* 	total[p->node.numOfTaxa][index] =  p->node.num; */
/* 	index++; */
/*     } */
/* } */

void ReadFMA(int & n, char* filename, Alinements ** InputData);
int** cmpressed(int** Mat, int n, int & newLn, int length);

#endif
