/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    April 9th, 2006
 Update:  April 9th, 2006
 Program: This is software for compressing site patterns.

 Input:   The alignment formatted as the multi FASTA format form.

 Output:  List of site patterns.
 
 Modified for EMGNJ.

***********************************************************************/

#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>

#include "cmpressed.h"
#include "Reading.h"
#include "Seq.h"


using namespace std;
 
/* ----------------------------------------------------------------- */
int main(int argc, char *argv[]) {
  Alinements * InputData;
  int n = 0, **Mat, length, **cmpMatrix, newLn;
  char filename[127];

  if(argc < 2){
    cerr << "Please enter the input file name." << endl;
    exit(0);
  }
  strcpy(filename, argv[1]);

  ReadFMA(n, filename, &InputData);

  removeDash(&InputData, n);
  length = InputData[0].DNA.length();
  Mat = DNAMat(InputData, n, length);
  cout << length << endl;
 
  cmpMatrix = cmpressed(Mat, n, newLn, length);

  for(int i = 0; i < (n + 1); i++){
    for(int j = 0; j < newLn; j++)
      cout << cmpMatrix[i][j] << " ";
    cout << endl;
  }

  // tree.preorder();
  for(int i = 0; i < n; i++) delete [] Mat[i];
  delete Mat;
  return 0;
}
